# TODO: restructure the specfile
# TODO: restructure the scripts
# (now it is merely a heap of parts of the 2 other pkgs)

Name: console-common-scripts
Version: 0.2.2
Release: alt1.2

Group: System/Configuration/Other
Summary: Console configuration activation and management
License: GPL
Packager: Ivan Zakharyaschev <imz@altlinux.org>

BuildArch: noarch

# As the main backend and data for it:
Requires: console-tools_or_kbd console-data

# due to /sbin/setsysfont's package change
Conflicts: startup < 0.9.7-alt1
# due to files moved from console-tools
Conflicts: console-tools < 0.2.3-ipl29mdk

# due to 
#Requires: ...setsysfont.backends
#Requires: ...setsyskeytable.backends

Requires(post): %post_service
Requires(preun): %preun_service
# keytable init script uses tr, cut, zgrep:
Requires(post,preun): coreutils gzip-utils
Requires: coreutils gzip-utils
# init scripts are run on installation:
Requires(post,preun): console-tools_or_kbd console-data

Source1: setsysfont

Source2: keytable.init
Source6: configure_keyboard
Source7: configure_keyboard.sh
Source8: configure_keyboard.csh

# from Mdk console-tools:
# on PPC we need to see whether mac or Linux keycodes are being used - stew
Source9: keytable.init.ppc

Source24: setsyskeytable
Source25: consolesaver.init
Source26: vt_activate_user_map
Source27: console.sh
Source28: console.csh
Source29: vt_activate_unicode

%description
This package is required if you have an interactive system with console.
The package is dedicated to both system-wide and per-user Linux console/other VT 
configuration.

It is responsible for the ways the console configuration is managed, 
stored and used (activated), either at system-boot time 
or user session startup. 
It defines the set of parameters that constitute the console configuration.
It provides the following main groups of scripts:
- activation scripts (= making use of the configuration);
- administration scripts (= managing the stored configuration) 
  [TODO, connect with ALT configurator?].
Also it provides auxiliary methods to access the configuration parameters
to be used by backend tools.

The primary backend tools this package uses are console-tools or kbd.

%install
%__mkdir_p "$RPM_BUILD_ROOT"
pushd "$RPM_BUILD_ROOT"

# Activation scripts:
%__install -pD -m755 %SOURCE1 ./sbin/setsysfont
%__install -pD -m755 %SOURCE2 .%_initdir/keytable

%__install -pD -m755 %SOURCE6 .%_datadir/%name/configure_keyboard
%__install -pD -m644 %SOURCE7 .%_sysconfdir/profile.d/configure_keyboard.sh
%__install -pD -m644 %SOURCE8 .%_sysconfdir/profile.d/configure_keyboard.csh

%__install -pD -m755 %SOURCE24 ./sbin/setsyskeytable
%__install -pD -m755 %SOURCE25 .%_initdir/consolesaver

%__install -pD -m755 %SOURCE26 .%_datadir/%name/vt_activate_user_map
%__install -pD -m644 %SOURCE27 ./etc/profile.d/console.sh
%__install -pD -m644 %SOURCE28 ./etc/profile.d/console.csh

%__install -pD -m755 %SOURCE29 .%_datadir/%name/vt_activate_unicode

# Config files:
%__install -d -m755 ./etc/sysconfig/
touch .%_sysconfdir/sysconfig/{consolefont,keyboard}
%__mkdir_p .%_sysconfdir/sysconfig/console
touch .%_sysconfdir/sysconfig/console/setterm

popd #"$RPM_BUILD_ROOT"

#
# This was a part of a %%post script.
#
# Probably this was needed for some old configuration tools. Commenting
#it out.
#if [ -s %_sysconfdir/sysconfig/keyboard ] ; then
#    . %_sysconfdir/sysconfig/keyboard
#    if [ -n "$KEYTABLE" ] ; then
#        KT=`echo $KEYTABLE | sed -e "s/.*\///g" | sed -e "s/\..*//g"`
#    fi
#fi

# This could be included in keytable stop:
#   if [ -d %_sysconfdir/sysconfig/console ] ; then
#      if [ -n "$SYSFONT" ]; then
#         cp -fp %kbddatadir/consolefonts/$SYSFONT* %_sysconfdir/sysconfig/console
#      fi
#      if [ -n "$UNIMAP" ]; then
#         cp -fp %kbddatadir/consoletrans/$UNIMAP* %_sysconfdir/sysconfig/console
#      fi
#      if [ -n "$SYSFONTACM" ]; then
#         cp -fp %kbddatadir/consoletrans/$SYSFONTACM* %_sysconfdir/sysconfig/console
#      fi
#   fi

# The code required for the transition to the new package, which
# owns some of the files that belonged to console-tools or startup pkgs before,
# is repeated twice: in %%post and in %%triggerpostun -- this way it works,
# and the other ways it doesn't (when not repeated twice) (I tested this 
# thoroughly).
%post
if [ "$1" -eq 1 ]; then # Fight the mess on the *1st* installation:
# Repeat %%triggerpostun's here (otherwise keeping files doesn't succeed):
for f in %_sysconfdir/sysconfig/{consolefont,keyboard,console/setterm}; do
	if [ ! -f "$f" ]; then
	        if [ -f "$f".rpmsave ]; then
	                %__cp -pfv "$f".rpmsave "$f"
	        elif [ -f "$f".rpmnew ]; then
	                %__cp -pfv "$f".rpmnew "$f"
	        fi
	fi
done
fi

%post_service keytable
%post_service consolesaver

%preun
%preun_service keytable
%preun_service consolesaver

# Inherited from startup-0.9.6-alt1 (a copy):
%triggerpostun -- initscripts < 1:5.49.1-alt1
for f in %_sysconfdir/sysconfig/{console/setterm,keyboard}; do
	if [ ! -f "$f" ]; then
	        if [ -f "$f".rpmsave ]; then
	                %__cp -pfv "$f".rpmsave "$f"
	        elif [ -f "$f".rpmnew ]; then
	                %__cp -pfv "$f".rpmnew "$f"
	        fi
	fi
done
# Analogous:
%triggerpostun -- startup < 0:0.9.7-alt1
for f in %_sysconfdir/sysconfig/{console/setterm,keyboard}; do
	if [ ! -f "$f" ]; then
	        if [ -f "$f".rpmsave ]; then
	                %__cp -pfv "$f".rpmsave "$f"
	        elif [ -f "$f".rpmnew ]; then
	                %__cp -pfv "$f".rpmnew "$f"
	        fi
	fi
done
# Analogous:
%triggerpostun -- console-tools < 0:0.2.3-ipl29mdk
for f in %_sysconfdir/sysconfig/consolefont; do
	if [ ! -f "$f" ]; then
	        if [ -f "$f".rpmsave ]; then
	                %__cp -pfv "$f".rpmsave "$f"
	        elif [ -f "$f".rpmnew ]; then
	                %__cp -pfv "$f".rpmnew "$f"
	        fi
	fi
done

# Relocation of the init scripts (%%post_service does chkconfig, too):
/sbin/chkconfig --add keytable || echo "chkconfig failed adding keytable: add it manually if you need"
/sbin/chkconfig --add consolesaver || echo "chkconfig failed adding consolesaver: add it manually if you need"


%files
# Activation scripts:
# from startup:
/sbin/setsysfont
# from console-tools:
/sbin/setsyskeytable
%attr(755,root,root) %config %_initdir/*
%attr(755,root,root) %config %_sysconfdir/profile.d/*.sh
%attr(755,root,root) %config %_sysconfdir/profile.d/*.csh
%_datadir/%name

# Config files:
# from startup + console-tools:
%config(noreplace) %verify(not md5 mtime size) %_sysconfdir/sysconfig/consolefont
%config(noreplace) %verify(not md5 mtime size) %_sysconfdir/sysconfig/keyboard
%dir %_sysconfdir/sysconfig/console
%config(noreplace) %verify(not md5 mtime size) %_sysconfdir/sysconfig/console/setterm

%changelog
* Tue Aug 30 2005 Alexey Gladkov <legion@altlinux.ru> 0.2.2-alt1.2
- vt_activate_unicode bugfix.

* Wed Aug 17 2005 Stanislav Ievlev <inger@altlinux.org> 0.2.2-alt1.1
- added support for unicode_start

* Fri Apr  8 2005 Ivan Zakharyaschev <imz@altlinux.ru> 0.2.2-alt1
- /sbin/setsyskeytable: undo 0.1.2-alt1 (doesn't work) and 0.2.1-alt1 (no need).

* Fri Apr  8 2005 Ivan Zakharyaschev <imz@altlinux.ru> 0.2.1-alt3
- The condition of triggerpostun's for console-tools improved
  (that keep the initscripts up).

* Fri Apr  8 2005 Ivan Zakharyaschev <imz@altlinux.ru> 0.2.1-alt2
- Better pre-deps.

* Thu Apr  7 2005 Ivan Zakharyaschev <imz@altlinux.ru> 0.2.1-alt1
- Make it work with kbd:
  + /sbin/setsysfont: setfont needs ".acm" suffix;
  + /sbin/setsyskeytable: hide console-tools/kbd deps from RPM.

* Thu Apr  7 2005 Ivan Zakharyaschev <imz@altlinux.ru> 0.1.2-alt1
- /sbin/setsysfont: fix errors (do always read /etc/sysconfig/consolefont).
- /sbin/setsyskeytable: minor improvements (for booting with serial output).

* Mon Apr  4 2005 Ivan Zakharyaschev <imz@altlinux.ru> 0.1.1-alt1
- Initial release.
- Moved the following components into this package: 
   + from startup pkg: /sbin/setsysfont, 
     %_sysconfdir/sysconfig/{console/setterm,keyboard};
   + from console-tools pkg: /sbin/setsyskeytable, 
     %_initdir/{keytable,consolesaver},
     %_sysconfdir/profile.d/{configure_keyboard,console}.* 
     + DEPS in %_datadir/%name/,
     %_sysconfdir/sysconfig/consolefont
